# Features

## Existing

* [x] Modular structure while providing a quick solution to start your project (the main crate)
* [x] Powered by the parallel ECS library [Specs]
* [x] [gfx]-based rendering engine with high customizability
* [x] Input abstraction for keyboard and mouse, bindings defined in config files
* [x] Parallel asset loading with high extensibility and hot-reloading
* [x] Vertex skinning and property animation
* [x] 3D audio with support for multiple emitters
* [x] Sprite rendering and texture animation
* [x] Basic UI support for text, text fields, buttons and images
* [x] Scenes can be imported from [glTF] files
* [x] Includes a simple state manager

## Planned

* [ ] Networking
* [ ] Scripting support
* [ ] Defining scenes and prefabs with RON files
* [ ] Gamepad support
* [ ] Platform support: Android, iOS
* [ ] Modular, composable and extensible editor that can be fully controlled by a REPL

[Specs]: https://github.com/slide-rs/specs
[gfx]: https://github.com/gfx-rs/gfx
[glTF]: https://www.khronos.org/gltf/
